#include <cstdlib>
#include <cstdio>

static int cmpint(const void *p1, const void *p2)
{
    return *(int *) p1 - *(int *) p2;
}

int main()
{
    int i, j, k, l, L, S, M, D, B, sum, from, p_i, p_j, p_k, p_l;
    long long int res;
    int *s, *m, *d, *b;

    while(scanf("%d%d%d%d%d", &L, &S, &M, &D, &B) == 5 && !(L == 0 && S == 0 && M == 0 && D == 0 && B == 0))
    {
        s = new int[S];
        m = new int[M];
        d = new int[D];
        b = new int[B];
        for (i=0; i<S; i++)
        {
            scanf("%d", &s[i]);
        }
        for (i=0; i<M; i++)
        {
            scanf("%d", &m[i]);
        }
        for (i=0; i<D; i++)
        {
            scanf("%d", &d[i]);
        }
        for (i=0; i<B; i++)
        {
            scanf("%d", &b[i]);
        }

        qsort(s, S, sizeof(int), cmpint);
        qsort(m, M, sizeof(int), cmpint);
        qsort(d, D, sizeof(int), cmpint);
        qsort(b, B, sizeof(int), cmpint);

        sum = s[0] + m[0] + d[0] + b[0];

        i = j = k = l = 1;
        while (i < S && sum + s[i] - s[i-1] <= L)
        {
            sum += s[i] - s[i-1];
            i++;
        }
        while (j < M && sum + m[j] - m[j-1] <= L)
        {
            sum += m[j] - m[j-1];
            j++;
        }
        while (k < D && sum + d[k] - d[k-1] <= L)
        {
            sum += d[k] - d[k-1];
            k++;
        }
        while (l < B && sum + b[l] - b[l-1] <= L)
        {
            sum += b[l] - b[l-1];
            l++;
        }

        res = i * j * k * l;

        while (true)
        {
            if (l > 1)
            {
                sum -= b[l];
                l--;
                from = 3;
            }
            else if (k > 1)
            {
                sum -= d[k];
                k--;
                from = 2;
            }
            else if (j > 1)
            {
                sum -= m[j];
                j--;
                from = 1;
            }
            else if (i > 1)
            {
                sum -= s[i];
                i--;
                from = 0;
            }
            else
            {
                break;
            }

            p_l = l;
            p_k = k;
            p_j = j;
            p_i = i;

            while (from > 0 && i < S && sum + s[i] - s[i-1] <= L)
            {
                sum += s[i] - s[i-1];
                i++;
            }
            while (from > 1 && j < M && sum + m[j] - m[j-1] <= L)
            {
                sum += m[j] - m[j-1];
                j++;
            }
            while (from > 2 && k < D && sum + d[k] - d[k-1] <= L)
            {
                sum += d[k] - d[k-1];
                k++;
            }
            while (from > 3 && l < B && sum + b[l] - b[l-1] <= L)
            {
                sum += b[l] - b[l-1];
                l++;
            }

            if (i-p_i > 0 || j-p_j > 0 || k-p_k > 0 || l-p_l > 0)
            {
                res += (
                           (i-p_i > 0 ? i-p_i : p_i) *
                           (j-p_j > 0 ? j-p_j : p_j) *
                           (k-p_k > 0 ? k-p_k : p_k) *
                           (l-p_l > 0 ? l-p_l : p_l)
                       );
            }
        }


        printf("%lld\n\n", res);

        delete [] s;
        delete [] m;
        delete [] d;
        delete [] b;
    }

    return 0;
}
